"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getSignedVAAHash = void 0;
const ethers_1 = require("ethers");
const __1 = require("..");
const utils_1 = require("../utils");
function getSignedVAAHash(signedVAA) {
    const body = utils_1.extractBodyFromVAA(signedVAA);
    const bodyHex = __1.uint8ArrayToHex(body);
    return ethers_1.ethers.utils.solidityKeccak256(["bytes"], [ethers_1.ethers.utils.solidityKeccak256(["bytes"], ["0x" + bodyHex])]);
}
exports.getSignedVAAHash = getSignedVAAHash;
