import { Address, ContractState, TestContractResult, ContractFactory, TestContractParams, ContractInstance } from "@alephium/web3";
export declare namespace EmptyTypes {
    type Fields = {
        a: bigint;
        b: bigint;
    };
    type State = ContractState<Fields>;
}
declare class Factory extends ContractFactory<EmptyInstance, EmptyTypes.Fields> {
    at(address: string): EmptyInstance;
    tests: {
        foo: (params: Omit<TestContractParams<EmptyTypes.Fields, never>, "testArgs">) => Promise<TestContractResult<null>>;
    };
}
export declare const Empty: Factory;
export declare class EmptyInstance extends ContractInstance {
    constructor(address: Address);
    fetchState(): Promise<EmptyTypes.State>;
}
export {};
